#property tester_no_cache

#include "Functions.mqh"

sinput EFunc TargetFunction = Skin;
sinput double X01 = 0;
sinput double X02 = 0;
sinput double X03 = 0;
sinput double X04 = 0;
sinput double X05 = 0;
sinput double X06 = 0;
sinput double X07 = 0;
sinput double X08 = 0;
sinput double X09 = 0;
sinput double X10 = 0;
sinput ulong Cycles = 10000;
sinput uint Parameters = 2; // Parameters (2, 4, 6, 8, 10)

C_Function *fptr;
double X[10];

void OnTesterInit()
{
  for(uint i = 0; i < Parameters; ++i)
  {
    ParameterSetRange(StringFormat("X%02d", i + 1), true, 0, 0.0, 1.0 / Cycles, 1.0);
  }
}

void OnTesterDeinit()
{
}

int OnInit()
{
  fptr = SelectFunction(TargetFunction);
  X[0] = X01;
  X[1] = X02;
  X[2] = X03;
  X[3] = X04;
  X[4] = X05;
  X[5] = X06;
  X[6] = X07;
  X[7] = X08;
  X[8] = X09;
  X[9] = X10;
  return INIT_SUCCEEDED;
}

double OnTester()
{
  double args[10];
  
  for(uint i = 0; i < Parameters; ++i)
  {
    if(i % 2 == 0)
      args[i] = Scale(X[i], 0, 1, fptr.GetMinX(), fptr.GetMaxX());
    else
      args[i] = Scale(X[i], 0, 1, fptr.GetMinY(), fptr.GetMaxY());
  }
  const double f = fptr.CalcFunc(args, Parameters / 2);
  delete fptr;
  ArrayPrint(args, 8, NULL, 0, Parameters);
  return f;
}

void OnDeinit(const int reason)
{
  //
}

double Scale(double In, double InMIN, double InMAX, double OutMIN, double OutMAX, bool Revers = false)
{
  if(OutMIN == OutMAX) return (OutMIN);
  if(InMIN == InMAX) return ((OutMIN + OutMAX) / 2.0);
  else
  {
    if(Revers)
    {
      if(In < InMIN) return (OutMAX);
      if(In > InMAX) return (OutMIN);
      return (((InMAX - In) * (OutMAX - OutMIN) / (InMAX - InMIN)) + OutMIN);
    }
    else
    {
      if(In < InMIN) return (OutMIN);
      if(In > InMAX) return (OutMAX);
      return (((In - InMIN) * (OutMAX - OutMIN) / (InMAX - InMIN)) + OutMIN);
    }
  }
}
